# ![repo-banner](.attachments/Images/repo-banner.png)

## Summary

Smouldering Beach Ball consists of  a .Net Standard 2.0 library, a console program and a "Test Centre". The purpose of this repository is to provide a way for people to create placeholder images. It does this by making the library available as a NuGet package and providing a console program. The console program is a standard alone program so there is no installer..

### Pre-Requisites

- Visual Studio 2017+
- F# (4.1+)
- xUnit
- FsCheck
- Console.Waterworks
- .Net 4.7
- .Net Standard (2.0)

## SmoulderingBeachBall (Library/NuGet Package)

This is a F# .Net Standard library. You can install this package via the Package Manager Console with the following command;

```powershell
// Make sure you change the version number to the one you want.
Install-Package SmoulderingBeachBall -Version 1.0.0
```

If you are using the .Net CLI, you can use the following command;

```powershell
// Again, make sure you change the version number to the one you want.
dotnet add package SmoulderingBeachBall --version 1.0.0
```

For further information about this project, please visit the [wiki](https://git.abbether.net/craig.oates/Smouldering-Beach-Ball/wiki).

## Smouldering Beach Ball CLI

This project is an F# console program, built on top of .Net 4.7\. You use it by entering commands and awaiting the result. It uses [Console.Waterworks](https://git.abbether.net/craig.oates/Console.Waterworks) to parse the commands so, if you want to extend it, I recommend you read its [wiki](https://git.abbether.net/craig.oates/Console.Waterworks/wiki). If you want to get going straight away, I recommend using the ``draw-default`` command. All you need to specify is the width and height of the image and it will create an image and save it to your desktop.

**Tip: Enter ``help`` for a list of available commands or ``cheat`` if you prefer them rendered in a PDF with a nicer layout. The command line interface(C.L.I.) will save the PDF on your desktop.**

For further information, please visit the [wiki](https://git.abbether.net/craig.oates/Smouldering-Beach-Ball/wiki).

![screenshot-1](.attachments/Images/screenshot-1.png)

## Test Centre

This project holds all the tests for this solution. If uses a combination of unit tests ([xUnit](http://xunit.github.io/)) and property tests ([FsCheck](https://fscheck.github.io/FsCheck/)). If you are unfamiliar with either of them, click on their links for more information. Also, all the tests are accessible in Visual Studio's Test Explorer. This means you can identify failing tests with ease.

![screenshot-2](.attachments/Images/screenshot-2.png)

## About the Creator

Hi, my name is Craig and I am the creator of Smouldering Beach Ball. Thanks for checking it out.

- Email: craig@craigoates.net
- Web: [http://www.craigoates.net](http://www.craigoates.net/)
- Project:  [http://www.craigoates.net/Software/project/11](http://www.craigoates.net/Software/project/11)
