﻿#load "Domain.fs"
#load "InternalServices.fs"
#load "Services.fs"

open System.Drawing
open System.Drawing.Imaging
open SmoulderingBeachBall.Domain.DomainTypes
open SmoulderingBeachBall.Services

// INITIAL IDEA ===============================================================

let width = 500
let height = 500
let colour = Brushes.BurlyWood
let testPath = "C:/users/craig/desktop/test.png"
let draw () =
    use bmp = new Bitmap(width, height)
    use gr = Graphics.FromImage(bmp)
    gr.FillRectangle(colour, new Rectangle(0, 0, bmp.Width, bmp.Height))
    gr.DrawImage(bmp, 0, 0)
    bmp.Save(testPath, ImageFormat.Png)

// Smouldering Beach Ball Library Code ========================================

let borderOverlay =
    { colour = Brushes.BlueViolet;
      overlayType = Border }

let fullOverlay =
    { colour = Brushes.Fuchsia;
      overlayType = Full }

let imageSpec =
    { width = 500;
      height = 500;
      colour = Brushes.Yellow;
      filePath = "C:/users/craig/desktop/";
      // Change this to flip between border/full overlay or None.
      overlay = Some fullOverlay }

makeImage imageSpec |> Async.RunSynchronously